% This program demonstrates work with ODBC (output of data from Database)
% Created by Plamen Sharapanov

% If the database is empty then start "db_insert.pro" in order to fill it

?-
  getCnnString(STR_Cnn),
  open_db(STR_Cnn, Obj_cnn),
  open_rs(Obj_cnn, Obj_rs),
  read_all(Obj_rs, N_CountryCode, STR_CountryName),
  write(N_CountryCode + " - " + STR_CountryName), nl,
  fail.

% uncomment your DB Source:

getCnnString("Provider=Microsoft.Jet.OLEDB.4.0;Data Source="+this_program_path+"\\db.mdb").
%getCnnString(`Provider=MSDASQL.1;Extended Properties="DBQ=`+this_program_path+`\\db.xls;Driver={Microsoft Excel Driver (*.xls)};"`).

open_db(STR_Cnn, Obj_cnn) :-
  write("--open_db--"), nl,
  Obj_cnn is server("ADODB.Connection"),
  Obj_cnn.'ConnectionString' := STR_Cnn,
  Obj_cnn.open().

open_rs(Obj_cnn, Obj_rs) :-
  write("--open_rs--"), nl,
  Obj_rs is Obj_cnn.execute("select * from country").

read_all(Obj_rs, N_CountryCode, STR_CountryName) :- 
  repeat,
  B_EOF is Obj_rs.'EOF',
  (B_EOF->
    cut(3),
    write("--end--"), nl,
    fail
  ),
  process_line(Obj_rs, N_CountryCode, STR_CountryName),
  Obj_rs.'MoveNext'().

process_line(Obj_rs, N_CountryCode, STR_CountryName) :-
  Obj_Fields is Obj_rs.'Fields',
  Obj_Field_CountryCode is Obj_Fields.'Item'("country_code"),
  N_CountryCode is Obj_Field_CountryCode.value,
  Obj_Field_CountryName is Obj_Fields.'Item'("country_name"),
  STR_CountryName is Obj_Field_CountryName.value.
