% Made by Antani Gospodinov
% student at the Faculty of Mathematics and Informatics,
% University of Sofia

?-
  G_T:= 0,
  G_SMax:= 70,
  G_Delta:= 0.05,
  G_CX:= 300,
  G_CY:= 300,
  G_Zoom:= 0.2,
  G_FrameTime:=0.1,
  G_KXX:=1,
  G_KXY:=1,
  G_KYX:=1,
  G_KYY:=1,
  G_AXX:=1,
  G_AXY:=1,
  G_AYX:=1,
  G_AYY:=1,
  window(title("Archimedean spiral"), size(2*G_CX, 2*G_CY), paint_indirectly).

r_x(X, Y, A, Res):-
  Res is X * cos(2*pi*A) - Y * sin(2*pi*A).

r_y(X, Y, A, Res):-
  Res is Y * cos(2*pi*A) + X * sin(2*pi*A).

time_func(end):-
  G_T:= G_T + G_FrameTime,
  update_window(_).

win_func(paint):-
  pen(3, rgb(0, 0, 255)),
  set(last_point(G_CX, G_CY)),
  for(I, 0, G_SMax / G_Delta),
    	S is I * G_Delta,
	r_x(G_KXX * S * sin(S * G_AXX), G_KXY * S * cos(S * G_AXY), G_T, RX),
	r_y(G_KYX * S * sin(S * G_AYX), G_KYY * S * cos(S * G_AYY), G_T, RY),
	PX is RX / G_Zoom + G_CX,
	PY is RY / G_Zoom + G_CY,
	last_point(A, B),
	line(A, B, PX, PY),
	set(last_point(PX, PY)),
  fail.

win_func(init):-
  Timer:= set_timer(_, G_FrameTime, time_func),
  menu(normal, action(menu_normal), text("normal") ),
  menu(normal, action(menu_spinny), text("spinny") ),
  menu(normal, action(menu_stretchy), text("stretchy") ),
  menu(normal, action(menu_butterfly), text("butterfly") ),
  menu(normal, action(menu_wave), text("wave") ).


menu_normal(press):-
  G_KXX:= 1,
  G_KXY:= 1,
  G_KYX:= 1,
  G_KYY:= 1,
  G_AXX:= 1,
  G_AXY:= 1,
  G_AYX:= 1,
  G_AYY:= 1.

menu_spinny(press):-
  G_KXX:= 2,
  G_KXY:= 1,
  G_KYX:= 2,
  G_KYY:= 1.

menu_stretchy(press):-
  G_KXX:= 1,
  G_KXY:= 2,
  G_KYX:= 2,
  G_KYY:= 1.

menu_butterfly(press):-
  G_AXX:= 2,
  G_AXY:= 1,
  G_AYX:= 2,
  G_AYY:= 1.

menu_wave(press):-
  G_AXX:= 1,
  G_AXY:= 2,
  G_AYX:= 3,
  G_AYY:= 2.

  
