menu_pause(press) :-
  G_Pause := 1 - G_Pause,
  modify_menu(G_Menu_Time, 1, (G_Pause =:= 1 -> checked else normal), _ ).

menu_fast_speed(press) :-
  G_FastSpeed:=(G_FastSpeed=:=1 -> 0 else 1),
  change_speed.
menu_normal_speed(press) :-
  (G_FastSpeed=\=0->
    G_FastSpeed:=0,
    change_speed
  ).
menu_slow_motion(press) :-
  G_FastSpeed:=(G_FastSpeed=:= -1 -> 0 else -1),
  change_speed.

change_speed:-
  modify_menu(G_Menu_Time, 4+G_Last_Speed, normal, _ ),
  modify_menu(G_Menu_Time, 4+G_FastSpeed, checked, _ ),
  G_Last_Speed := G_FastSpeed,
  set_main_window_text,
  Interval := (G_FastSpeed =:= 1 -> 0.01 else (G_FastSpeed =:= 0 -> 0.1 else 0.5)),
  (not(var(G_Timer)) -> kill_timer(_, G_Timer)),
  G_Timer := set_timer(_, Interval, time_func).

set_main_window_text:-
  (G_FastSpeed=\= -1; G_Run_Invisible =:= 1 ->
    Fast:= (G_Run_Invisible =:= 1 -> " (Invisible)" else (G_FastSpeed=:=1 -> " (fast)" else "")),
    set_text("Metro "+G_Time//10+Fast, _)
  else
    Slow:= (G_Time mod 10=:=0 -> ".0" else ""),
    set_text("Metro "+G_Time/10+Slow, _)
  ).

menu_unexpected_delay(press) :-
  G_Unexpected_Delay := 1-G_Unexpected_Delay,
  modify_menu(G_Menu_Time, 7, (G_Unexpected_Delay =:= 1 -> checked else normal), _ ).

menu_accident(press) :-
  G_Accident := 1-G_Accident,
  modify_menu(G_Menu_Time, 8, (G_Accident =:= 1 -> checked else normal), _ ).

menu_number(press) :-
  G_MenuNumber := (G_MenuNumber-1) mod 8,
  update_window(_).

menu_minus(press) :-
  G_MenuNumber := (G_MenuNumber+1) mod 8,
  update_window(_).

menu_map_list(press) :-
  G_map_list := 1 - G_map_list,
  (G_map_list =:= 0 ->
    modify_menu(G_Menu_Show, 2, normal, "Map -> List\tL"),
    modify_menu(G_Menu_Show, 3, grayed, _ )
  else
    modify_menu(G_Menu_Show, 2, checked, "List -> Map\tL"),
    modify_menu(G_Menu_Show, 3, (G_Show_the_transfers =:= 1 -> checked else normal), _ )
  ),
  update_window(_).

menu_show_the_transfers(press) :-
  G_Show_the_transfers := 1 - G_Show_the_transfers,
  modify_menu(G_Menu_Show, 3, (G_Show_the_transfers =:= 1 -> checked else normal), _ ),
  update_window(_).

menu_follow_the_wagon(press) :-
  client_size(_, A, B),
  G_PosX1 := -0.6*A/G_Zoom,
  G_PosX2 := 0,
  follow_the_wagon,
  G_PosX := wagonX(G_The_Wagon) + G_PosX1 + G_PosX2,
  fix_small_pos(0.5*G_Xsize),
  update_window(_).

follow_the_wagon:-
  G_Follow_the_wagon := 1 - G_Follow_the_wagon,
  modify_menu(G_Menu_Show, 5, (G_Follow_the_wagon =:= 1 -> checked else normal), _ ).

menu_the_map_in_the_wagon(press) :-
  (G_Follow_the_wagon =:= 0 ->
    G_PosX2 := 0
  ),
  G_The_map_in_the_wagon := 1 - G_The_map_in_the_wagon,
  modify_menu(G_Menu_Show, 6, (G_The_map_in_the_wagon =:= 1 -> checked else normal), _ ),
  update_window(_).

menu_color_of_wagons(press) :-
  G_Color_of_wagons := 1 - G_Color_of_wagons,
  modify_menu(G_Menu_Show, 8, (G_Color_of_wagons =:= 1 -> checked else normal), _ ),
  update_window(_).

menu_more_info(press) :-
  G_More_Info := 1 - G_More_Info,
  modify_menu(G_Menu_Show, 9, (G_More_Info =:= 1 -> checked else normal), _ ),
  update_window(_).

Text is make_flags_text(I, Flag):- Flag =:= 1, !, Text := (wFlags(I)/\1=:=0-> "." else "*").
Text is make_flags_text(I, Flag):-
  NextFlag := Flag//2,
  Text := make_flags_text(I, NextFlag),
  Star := (wFlags(I)/\Flag=:=0 -> "." else "*"),
  Text := (wPosoka(I)=:=1 -> Star + "  " + Text else Text + "  " + Star).

make_text(0, I, Text):-
  (wJump(I) > 0 ->
    Text := wJump(I)+" : "+wStop(I)
  else (wJump(I)=:=0->
    Text := ""
  else
    Text := (wFlags(I)/\0x300=\=0 -> "Composing" else (wJump(I)=:= -1 -> "A" else (wJump(I)=:= -2 -> "B" else (wJump(I)=:= -3; wJump(I)=:= -4 -> "Ready" else "error"))))
  )).
make_text(1, I, Text):- Text := "#"+I+", line "+(wLine(I)+1).
make_text(2, I, Text):- Text := "x="+wagonX(I)/100.
make_text(3, I, Text):- Num := wFlags(I)//0x1000,
                        Pos := (wFlags(I)/\0x300)//0x100,
                        A := (Pos=:=0 -> "" else string_from_ASCII(first_ASCII("a")+Pos-1)),
                        Flags := make_flags_text(I, 64),
                        Text := (wPosoka(I)=:=1 -> Num + A + " " + Flags else Flags + " "+ A + Num).
make_text(4, I, Text):- Text := "s + "+wAcceleration(I)+" = "+wSpeed(I).
make_text(5, I, Text):- Text := "<"+wSpeed(I)+", "+wTargetSpeed(I)+">".
make_text(6, I, Text):- Text := "at "+wStopAt(I)/100+", c="+wCount(I).
make_text(7, I, Text):- 
  Text := (wPosoka(I)=:=1 -> wNext(I)+"<"+I+">"+wPrevious(I) else wPrevious(I)+"<"+I+">"+wNext(I)).

menu_zoom_in(press):- client_size(_,W,H), zoom(-1, W//2, H//2).
menu_zoom_out(press):- client_size(_,W,H), zoom(1, W//2, H//2).

menu_help(init):-
  menu( normal, action(menu_help1), text("How to travel?")),
  menu( normal, action(menu_help2), text("What is this program about?")),
  menu( normal, action(menu_help3), text("How does the new scheme work?")),
  menu( normal, action(menu_help4), text("Which train should I take?")),
  menu(separator),
  menu( normal, action(menu_help5), text("Useful Keys")).

menu_help1(press):-  message("How to travel?",
  "To board the train, click on it. To get off the train, click on the station.

If you want to jump far away, click on the small map (above) or in the big map (below) on the station which you want to see.",i).

menu_help2(press):-  message("What is this program about?",
  "We present a new scheme for the wagon movement which will increase the capacity of the metro tube with 50%. This will decrease the traveling time by 33% and the power consumption by 30%.",i).

menu_help3(press):-  message("How does the new scheme work?",
  "From the green platform departs a train which will stop at the next station. From the blue platform departs a train which will skip the next station and will stop at the second one. Similarly, the train from the yellow platform will stop only at the third station, and the one from the red platform, only at the fourth.",i).

menu_help4(press):-  message("Which train should I take?",
  "At every station is posted a scheme. At different stations, the schemes are different, because for the next station you have to take the train from the green platform, and which is the next station depends on where you are at the moment.

You can view the scheme as a map or as a list.

When you board the train, you will see another scheme inside. It shows which stations this train will stop at.",i).

menu_help5(press):-  message("Useful Keys",
  "You can zoom in and out by the buttons + and -. You can drag the field with the mouse. Also you can move by the arrows. Other possibility to move and zoom is by the mouse wheel.",i).

menu_file(init) :-
  menu( normal, action(menu_file_open), text("&Open...") ), % Open
  menu( normal, action(menu_file_last), text("&Load last") ),
  menu( normal, action(menu_file_heavy), text("Load (&Heavy Traffic)") ),
  menu( normal, action(menu_file_low), text("Load (&Low Traffic)") ),
  menu( normal, action(menu_file_save_last), text("&Save") ),
  menu( normal, action(menu_file_save_as), text("Save &As...") ). % &As

menu_show(init) :-
  menu(normal, action(menu_number), text("Next Label\t<, >") ),
  menu(normal, action(menu_map_list), text("Map -> List \tL") ),
  menu(normal, action(menu_show_the_transfers), text("Show the transfers\tT") ),
  menu(separator),
  menu(normal, action(menu_follow_the_wagon), text("Follow the wagon with number "+G_The_Wagon) ),
  menu(normal, action(menu_the_map_in_the_wagon), text("Show the map in the wagon\tW") ),
  menu(separator),
  menu(normal, action(menu_color_of_wagons), text("Color of wagons") ),
  menu(normal, action(menu_more_info), text("More Info") ).

menu_time(init) :-
  menu(normal, action(menu_pause), text("&Pause\tP") ),
  menu(separator),
  menu(normal, action(menu_slow_motion), text("&Slow Motion\tS") ),
  menu(normal, action(menu_normal_speed), text("&Normal Speed")),
  menu(normal, action(menu_fast_speed), text("&Fast Speed\tF") ),
  menu(separator),
  menu(normal, action(menu_unexpected_delay), text("Unexpected Delay") ),
  menu(normal, action(menu_accident), text("An Accident") ).

menu_traffic(init) :-
  menu(normal, action(menu_traffic1), text(G_Wagons_in_use//4 + " x 4 = " + G_Wagons_in_use + "\t100%") ),
  menu(normal, action(menu_traffic2), text(0.66*G_Wagons_in_use//2 + " x 2 = " + round(0.66*G_Wagons_in_use) + "\t66%") ),
  menu(normal, action(menu_traffic3), text(G_Wagons_in_use//4 + " x 2 = " + G_Wagons_in_use//2 + "\t50%") ),
  menu(normal, action(menu_traffic4), text(0.66*G_Wagons_in_use//2 + " x 1 = " + 0.66*G_Wagons_in_use//2 + "\t33%") ),
  menu(normal, action(menu_traffic5), text(G_Wagons_in_use//4 + " x 1 = " + G_Wagons_in_use//4 + "\t25%") ),
  menu(normal, action(menu_traffic6), text(0.66*G_Wagons_in_use//4 + " x 1 = " + 0.66*G_Wagons_in_use//4 + "\t16%") ),
  menu(normal, action(menu_traffic7), text(G_Wagons_in_use//8 + " x 1 = " + G_Wagons_in_use//8 + "\t12%") ),
  menu(normal, action(menu_traffic8), text("Stop\t0%") ).

menu_traffic1(press) :- traffic(1).
menu_traffic2(press) :- traffic(2).
menu_traffic3(press) :- traffic(3).
menu_traffic4(press) :- traffic(4).
menu_traffic5(press) :- traffic(5).
menu_traffic6(press) :- traffic(6).
menu_traffic7(press) :- traffic(7).
menu_traffic8(press) :- traffic(8).

traffic(N):-
  modify_menu(G_Menu_Traffic, G_Traffic, normal, _),
  init_statistic,
  make_traffic(N),
  modify_menu(G_Menu_Traffic, G_Traffic, checked, _).

menu_file_open(press) :-
  F is select_file( o, "Open a saved moment", "Metro Files (*.metro)\0*.metro\0All Files (*.*)\0*.*\0"),
  % write(F), nl,
  file_open(F).

menu_file_last(press) :- file_open("Last.metro").
menu_file_heavy(press) :- file_open("Heavy.metro").
menu_file_low(press) :- file_open("Low.metro").

file_open(File):-
  modify_menu(G_Menu_Traffic, G_Traffic, normal, _ ),
  H is open(File, "rb"),
  read_metro(H),
  close(H),
  init_menu_bars.

menu_file_save_as(press) :- G_New_Map_Number =:= G_Map_Number,
  F is select_file((true -> s else o), _, "Metro Files (*.metro)\0*.metro\0All Files (*.*)\0*.*\0"),
  H is open(F, "wb"), save_metro(H), close(H).
menu_file_save_last(press) :- G_New_Map_Number =:= G_Map_Number,
  H is open("Last.metro", "wb"), save_metro(H), close(H).

read_metro(H) :-
  G_Try_the_standard_scheme := get(H, int32),
  G_New_Map_Number := get(H, int32),
  G_Crazy_Speed := get(H, int32),
  G_Accident := get(H, int32),
  G_ExtraDistance := get(H, int32),
  G_Wagons_in_use := get(H, int32),
  G_time_period_fast := get(H, int32),
  G_Traffic := get(H, int32),
  G_The_Wagon := get(H, int32),
  G_PosX := get(H, int32),
  G_PosX1 := get(H, int32),
  G_PosX2 := get(H, int32),
  G_PosY := get(H, int32),
  G_PosSmall := get(H, int32),
  G_Zoom := get(H, float32),
  G_ScrollRange := get(H, int32),
  G_Time := get(H, int32),
  G_WagonNum := get(H, int32),
  G_NextColor := get(H, int32),
  G_Unexpected_Delay := get(H, int32),
  G_Energy_Saving := get(H, int32),
  G_Pause := get(H, int32),
  G_FastSpeed := get(H, int32),
  G_MenuNumber := get(H, int32),
  G_map_list := get(H, int32),
  G_Show_the_transfers := get(H, int32),
  G_Follow_the_wagon := get(H, int32),
  G_The_map_in_the_wagon := get(H, int32),
  G_Color_of_wagons := get(H, int32),
  G_More_Info := get(H, int32),
  G_Statistic_Course:= get(H, int32),
  G_Statistic_Time:= get(H, int32),
  G_Statistic_averSpeed:= get(H, int32),
  G_Statistic_Stations := get(H, int32),
  G_Statistic_Station_Stay := get(H, int32),
  G_Statistic_Max_Speed := get(H, int32),
  get_array(wagonX, H, max_wagons, int32),
  get_array(wagonY, H, max_wagons, int32),
  get_array(wPosoka, H, max_wagons, int32),
  get_array(wOldX, H, max_wagons, int32),
  get_array(wJump, H, max_wagons, int32),
  get_array(wStop, H, max_wagons, int32),
  get_array(wLine, H, max_wagons, int32),
  get_array(wSpeed, H, max_wagons, float32),
  get_array(wTargetSpeed, H, max_wagons, float32),
  get_array(wStopAt, H, max_wagons, int32),
  get_array(wAcceleration, H, max_wagons, float32),
  get_array(wCount, H, max_wagons, int32),
  get_array(wColor, H, max_wagons, int32),
  get_array(wNext, H, max_wagons, int32),
  get_array(wPrevious, H, max_wagons, int32),
  get_array(wTime, H, max_wagons, int32),
  get_array(wFlags, H, max_wagons, int32),
  get_array(first2, H, 3*8, int32),
  get_array(semaphore, H, 4, int32),
  get_array(statistic, H, 4, int32),
  get_array(line, H, 3, int32),
  get_array(trains_await, H, 3, int32),
  get_array(busy, H, 3, int32),
  make_traffic(G_Traffic).

save_metro(H) :-
  put(G_Try_the_standard_scheme, H, int32),
  put(G_Map_Number, H, int32),
  put(G_Crazy_Speed, H, int32),
  put(G_Accident, H, int32),
  put(G_ExtraDistance, H, int32),
  put(G_Wagons_in_use, H, int32),
  put(G_time_period_fast, H, int32),
  put(G_Traffic, H, int32),
  put(G_The_Wagon, H, int32),
  put(G_PosX, H, int32),
  put(G_PosX1, H, int32),
  put(G_PosX2, H, int32),
  put(G_PosY, H, int32),
  put(G_PosSmall, H, int32),
  put(G_Zoom, H, float32),
  put(G_ScrollRange, H, int32),
  put(G_Time, H, int32),
  put(G_WagonNum, H, int32),
  put(G_NextColor, H, int32),
  put(G_Unexpected_Delay, H, int32),
  put(G_Energy_Saving, H, int32),
  put(G_Pause, H, int32),
  put(G_FastSpeed, H, int32),
  put(G_MenuNumber, H, int32),
  put(G_map_list, H, int32),
  put(G_Show_the_transfers, H, int32),
  put(G_Follow_the_wagon, H, int32),
  put(G_The_map_in_the_wagon, H, int32),
  put(G_Color_of_wagons, H, int32),
  put(G_More_Info, H, int32),
  put(G_Statistic_Course, H, int32),
  put(G_Statistic_Time, H, int32),
  put(G_Statistic_averSpeed, H, int32),
  put(G_Statistic_Stations, H, int32),
  put(G_Statistic_Station_Stay, H, int32),
  put(G_Statistic_Max_Speed, H, int32),

  put_array(wagonX, H, max_wagons, int32),
  put_array(wagonY, H, max_wagons, int32),
  put_array(wPosoka, H, max_wagons, int32),
  put_array(wOldX, H, max_wagons, int32),
  put_array(wJump, H, max_wagons, int32),
  put_array(wStop, H, max_wagons, int32),
  put_array(wLine, H, max_wagons, int32),
  put_array(wSpeed, H, max_wagons, float32),
  put_array(wTargetSpeed, H, max_wagons, float32),
  put_array(wStopAt, H, max_wagons, int32),
  put_array(wAcceleration, H, max_wagons, float32),
  put_array(wCount, H, max_wagons, int32),
  put_array(wColor, H, max_wagons, int32),
  put_array(wNext, H, max_wagons, int32),
  put_array(wPrevious, H, max_wagons, int32),
  put_array(wTime, H, max_wagons, int32),
  put_array(wFlags, H, max_wagons, int32),
  put_array(first2, H, 3*8, int32),
  put_array(semaphore, H, 4, int32),
  put_array(statistic, H, 4, int32),
  put_array(line, H, 3, int32),
  put_array(trains_await, H, 3, int32),
  put_array(busy, H, 3, int32).

get_array(Array, H, Size, Type):-
  for(I, 0, Size),
    Array(I) := get(H, Type),
  fail.
get_array(_, _, _, _).

put_array(Array, H, Size, Type):-
  for(I, 0, Size),
    put(Array(I), H, Type),
  fail.
put_array(_, _, _, _).

win_func(paint):-
  (G_New_Map_Number =\= G_Map_Number ->
    text_out("This METRO file was saved with a different map.", pos(100, 100)),
    text_out("Try with \"Start from the beginning\".", pos(100, 140))
  else
    G_Run_Invisible =:= 0,
    (my_paint(G_PosX, G_PosY, G_Zoom, G_Zoom, big)
    ;
    ZoomX := 0.0034*G_Xsize/1863,
    my_paint(-25000+G_PosSmall, -2000, ZoomX, 0.02, small))
  ).

win_func(init):-
  menu( pop_up, action(menu_file), text("&File") ),
  G_Menu_Show := menu( pop_up, action(menu_show), text("&Show") ),
  G_Menu_Time := menu( pop_up, action(menu_time), text("&Time") ),
  G_Menu_Traffic := menu( pop_up, action(menu_traffic), text("Traffic") ),
  menu(right, action(menu_zoom_in), text("Zoom &In") ),
  menu(right, action(menu_zoom_out), text("Zoom &Out") ),
  menu(right, pop_up, action(menu_help), text("&Help") ),
  set_scroll_range(_,vertical,0,G_ScrollRange),
  set_scroll_range(_,horizontal,0,G_ScrollRange),
  init_menu_bars.

%win_func(key_down(Ch, Rep)):-
%  write(Ch), nl,
%  fail.

win_func(key_down(73, Rep)):- % I
  G_Run_Invisible := 1 - G_Run_Invisible, update_window(_). 
win_func(key_down(83, Rep)):- % S
  menu_slow_motion(press). 
win_func(key_down(70, Rep)):- % F
  menu_fast_speed(press). 
win_func(key_down(80, Rep)):- % P
  menu_pause(press).
win_func(key_down(190, Rep)):- % >
  menu_minus(press).
win_func(key_down(188, Rep)):- % <
  menu_number(press).
win_func(key_down(76, Rep)):- % L
  menu_map_list(press). 
win_func(key_down(84, Rep)):- % T
  menu_show_the_transfers(press). 
win_func(key_down(87, Rep)):- % W
  menu_the_map_in_the_wagon(press). 
win_func(key_down(187, Rep)):- % +
  menu_zoom_in(press).
win_func(key_down(189, Rep)):- % -
  menu_zoom_out(press).
 
win_func(key_down(36, Rep)):- % home
  G_PosSmall := 0, fix_scroll_bar_h.
win_func(key_down(35, Rep)):- % end
  G_PosSmall := end_map, fix_scroll_bar_h.
win_func(key_down(45, Rep)):- % insert <- slow
  G_PosSmall := max(0, G_PosSmall-Rep*10000), fix_scroll_bar_h.
win_func(key_down(33, Rep)):- % page Up -> slow
  G_PosSmall := min(end_map, G_PosSmall+Rep*10000), fix_scroll_bar_h.
win_func(key_down(46, Rep)):- % del <- fast
  G_PosSmall := max(0, G_PosSmall-Rep*50000), fix_scroll_bar_h.
win_func(key_down(34, Rep)):- % page Down -> fast
  G_PosSmall := min(end_map, G_PosSmall+Rep*50000), fix_scroll_bar_h.

win_func(key_down(Char, Rep)):-
  Xold:=G_PosX,
  Yold:=G_PosY,
  (Char=37-> % left
    G_PosX:= G_PosX - G_Xsize*0.02*Rep/G_Zoom
  ),
  (Char=39-> % right
    G_PosX:= G_PosX + G_Xsize*0.02*Rep/G_Zoom
  ),
  (Char=38-> % up
    G_PosY:= G_PosY - G_Ysize*0.02*Rep/G_Zoom
  ),
  (Char=40-> % down
    G_PosY:= G_PosY + G_Ysize*0.02*Rep/G_Zoom
  ),
  move(Xold, Yold).

win_func(size(X,Y)):-
  G_Xsize:=X,
  G_Ysize:=Y,
  update_window(_).

win_func(mouse_click(X, Y)):-
  (Y<100->
    G_Variant:= small,
    Xold:=G_PosX,
    Yold:=G_PosY,
    ZoomX := 0.0034*G_Xsize/1863,
    ZoomY:= 0.02,
    G_PosX:= -25000+G_PosSmall+X/ZoomX-0.5*G_Xsize/G_Zoom,
    G_PosY:= -2000+Y/ZoomY-100/G_Zoom-0.25*(G_Ysize-100)/G_Zoom,
    (G_Follow_the_wagon =:= 1 ->
      follow_the_wagon
    ),
    move(Xold, Yold)
  else
    G_Variant:= big,
    Xp := G_PosX + X/G_Zoom,
    Yp := G_PosY + Y/G_Zoom,
    (350 < Yp, Yp < 2150 ->
      (750 < Yp, Yp < 1750->
        find_wagon(Xp, Yp)
      else (station_at_pos(Xp)->
        (G_Follow_the_wagon =:= 1 ->
          follow_the_wagon
        ),
        (G_The_map_in_the_wagon =:= 1 ->
          menu_the_map_in_the_wagon(press)
        )
      ))
    else (G_map_list =:= 0, G_The_map_in_the_wagon =:= 0, G_Zoom>0.08 ->
      PosY := 500,
      X1 := Xp + 6250,
      Y1 := Yp + 3125 - PosY,
      ((375 - Y1 mod 750)**2 + (250 - X1 mod 500)**2 < 10000 ->
        visible_station(N, Station, _, 8000, big),
        Y0 := Y1// 750 - 7, 0=<Y0, Y0<2,
        N2 := (X1 - Station)// 500 + 11,
        (Y0 =:= 0 -> N2 := 25-N2),
        (station(yes, N2, Station2, _, _, _) ->
          Xold:=G_PosX,
          Yold:=G_PosY,
          G_PosX:= G_PosX + Station2 - Station,
          fix_small_pos(X),
          (G_Follow_the_wagon =:= 1 ->
            follow_the_wagon
          ),
          move(Xold, Yold)
        )
      )
    ))
  ),
  G_moveX:=X,
  G_moveY:=Y,
  set_capture(_).

win_func(mouse_click_up(X, Y)):-
  G_moveX:=no,
  release_capture.

win_func(mouse_move(X, Y)):-
  (message_flags(left), G_moveX \= no ->
    Xold:=G_PosX,
    Yold:=G_PosY,
    (G_Variant=big->
      ZoomX:=G_Zoom,
      ZoomY:=G_Zoom
    else
      ZoomX := -0.0034*G_Xsize/1863,
      ZoomY:= -0.02
    ),
    G_PosX := G_PosX  + (G_moveX-X)/ZoomX,
    G_PosX2:= G_PosX2 + (G_moveX-X)/ZoomX,
    G_PosY := G_PosY  + (G_moveY-Y)/ZoomY,
    move(Xold, Yold),
    G_moveX:=X,
    G_moveY:=Y
  ).

win_func(scroll(horizontal,Type,Val)):-
  (Type=line->
    Step := 10000
  else (Type=page->
    Step := 100000
  else (Type=thumb_track->
    Step := (end_map+500000)/G_ScrollRange,
    Old := Val,
    Val := Val - G_Scroll_h,
    G_Scroll_h := Old
  else % thumb_moved_to
    G_Scroll_h := G_ScrollRange*(G_PosSmall/(end_map+500000)),
    fail
  ))),
  G_PosSmall := G_PosSmall + Step*Val,
  (G_PosSmall<0 -> G_PosSmall := 0),
  (G_PosSmall>end_map -> G_PosSmall := end_map),
  fix_scroll_bar_h.

win_func(scroll(vertical,Type,Val)):-
  Xold:=G_PosX,
  Yold:=G_PosY,
  (Type=line->
    Step := 0.02
  else (Type=page->
    Step := 0.3
  else (Type=thumb_track->
    Step := 0.02,
    Old := Val,
    Val := Val - G_Scroll_v,
    G_Scroll_v := Old
  else % thumb_moved_to
    G_Scroll_v := (G_ScrollRange-G_ScrollPage)//2,
    fail
  ))),
  G_PosY:= G_PosY + G_Ysize*Step*Val/G_Zoom,
  move(Xold, Yold).

win_func(mouse_wheel(Delta, X, Y)):-
  (message_flags(left); message_flags(middle); message_flags(ctrl)->
    client_pos(_,A,B),
    zoom(0-Delta, X-A, Y-B)
  else
    Yold:=G_PosY,
    G_PosY:= G_PosY - 3*G_Ysize*0.02*Delta/G_Zoom,
    move(G_PosX, Yold)
  ).

win_func(r_mouse_click(X, Y)):-
  (message_flags(ctrl)->
    zoom( 7, X, Y)
  else
    zoom(-7, X, Y)
  ). 

fix_small_pos(X):-
  ZoomX := 0.0034*G_Xsize/1863,
  G_PosSmall:= 25000+ G_PosX-X/ZoomX+0.5*G_Xsize/G_Zoom,
  (G_PosSmall<0 -> G_PosSmall := 0),
  (G_PosSmall>end_map -> G_PosSmall := end_map),
  fix_scroll_bar_h.

zoom(Delta, X, Y):-
  G_Zoom:=G_Zoom*0.9**Delta,
  G_PosX:= G_PosX - X* (1 - 0.9**Delta)/G_Zoom,
  G_PosY:= G_PosY - Y* (1 - 0.9**Delta)/G_Zoom,
  fix_scroll_bar_v,
  update_window(_).

fix_scroll_bar_v:-
  G_ScrollPage := (G_Zoom=<0.25 -> 1000*G_Zoom else 1500+1000*log(G_Zoom)/log(0.25)),
  G_Scroll_v := (G_ScrollRange-G_ScrollPage)//2,
  set_scroll_page(_,vertical,G_ScrollPage),
  set_scroll_pos(_,vertical,G_Scroll_v).

fix_scroll_bar_h:-
  G_Scroll_h := G_ScrollRange*(G_PosSmall/(end_map+500000)),
  set_scroll_page(_,horizontal,G_ScrollRange*500000/(end_map+500000)),
  set_scroll_pos(_,horizontal,G_Scroll_h),
  update_window(_).

move(Xold, Yold):-
  update_window(_).
  %scroll_window(_, floor(Xold*G_Zoom)-floor(G_PosX*G_Zoom), floor(Yold*G_Zoom)-floor(G_PosY*G_Zoom), 1).

put_grid(X2, Y2, X1, Y1, PosX, PosY, ZoomX, ZoomY, big):-
  (X1<X2-> A:=X1, B:=X2 else A:=X2, B:=X1),
  for(X, A, B, step(5000)),
  line((X-PosX)*ZoomX, (Y1-72-PosY)*ZoomY, (X-PosX)*ZoomX, (Y1+72-PosY)*ZoomY),
  fail.
put_grid(X2, Y2, X1, Y1, PosX, PosY, ZoomX, ZoomY, Variant).

get_metro_line(X1, Y1, X2, Y2, Sem1, Sem2, Variant):-
  metro_line(X1, Y1, X2, Y2, Sem1, Sem2).
get_metro_line(X1+Point, Y1, X2+Point, Y2, NewSem1, NewSem2, Variant):-
  visible_station(_, Point, FirstSemaphore, 20000, Variant),
  local_metro_line(X1, Y1, X2, Y2, Sem1, Sem2),
  NewSem1 := (Sem1=no-> no else Sem1+FirstSemaphore),
  NewSem2 := (Sem2=no-> no else Sem2+FirstSemaphore).
get_metro_line(X1+5000, Y, X2-5000, Y, no, no, Variant):-
  visible_station(Where, X1, _, 300000, Variant), % increase if distance between stations is more than 3 km 
  NextSt := Where+1,
  station(yes, NextSt, X2, _, _, _),
  (Y=1010; Y=1520).

my_draw_arc(X, Y, D, Q1, Q2, Open, Sign, PosX, PosY, ZoomX, ZoomY, Variant):-
  (Sign=:=1->
    draw_arc((X-D/2-PosX)*ZoomX, (Y-PosY)*ZoomY, (X+D/2-PosX)*ZoomX, (Y+D-PosY)*ZoomY, (Q1-PosX)*ZoomX, (Q2-PosY)*ZoomY, (X+Open-PosX)*ZoomX, (Y-PosY)*ZoomY)
  else
    draw_arc((X-D/2-PosX)*ZoomX, (Y-PosY)*ZoomY, (X+D/2-PosX)*ZoomX, (Y+D-PosY)*ZoomY, (X+Open-PosX)*ZoomX, (Y-PosY)*ZoomY, (Q1-PosX)*ZoomX, (Q2-PosY)*ZoomY)
  ).

init_menu_bars:-
  change_speed,
  (G_map_list =:= 0 ->
    modify_menu(G_Menu_Show, 2, normal, "Map -> List\tL"),
    modify_menu(G_Menu_Show, 3, grayed, _ )
  else
    modify_menu(G_Menu_Show, 2, checked, "List -> Map\tL"),
    modify_menu(G_Menu_Show, 3, (G_Show_the_transfers =:= 1 -> checked else normal), _ )
  ),
  modify_menu(G_Menu_Show, 5, (G_Follow_the_wagon =:= 1 -> checked else normal), "Follow the wagon with number " + G_The_Wagon ),
  modify_menu(G_Menu_Show, 6, (G_The_map_in_the_wagon =:= 1 -> checked else normal), _ ),
  modify_menu(G_Menu_Show, 8, (G_Color_of_wagons =:= 1 -> checked else normal), _ ),
  modify_menu(G_Menu_Show, 9, (G_More_Info =:= 1 -> checked else normal), _ ),
  modify_menu(G_Menu_Time, 1, (G_Pause =:= 1 -> checked else normal), _ ),
  modify_menu(G_Menu_Time, 7, (G_Unexpected_Delay =:= 1 -> checked else normal), _ ),
  modify_menu(G_Menu_Time, 8, (G_Accident =:= 1 -> checked else normal), _ ),
  modify_menu(G_Menu_Traffic, G_Traffic, checked, _ ),
  fix_scroll_bar_v,
  fix_scroll_bar_h.

