?-
  init(Search, Dir, Where),
  search(Search, Dir, Where).

find_and_open(Dir, R_Dir, F_Name, H_File, files):-
    F_Name := find_file(Dir+R_Dir+"\\*.add", type(file)),
    H_File := open(Dir+R_Dir+F_Name, "r").

find_and_open(Dir, R_Dir, F_Name, H_File, files):-
    F_Name := find_file(Dir+R_Dir+"\\*.spj", type(file)),
    H_File := open(Dir+R_Dir+F_Name, "r"),
    jump_over_SPJ_head(H_File).

find_and_open(Dir, R_Dir, F_Name, H_File, files):-
    F_Name := find_file(Dir+R_Dir+"\\*.pro", type(file)),
    H_File := open(Dir+R_Dir+F_Name, "r").

find_and_open(Dir, R_Dir, F_Name, H_File, files):-
    F_Name := find_file(Dir+R_Dir+"\\*.h", type(file)),
    H_File := open(Dir+R_Dir+F_Name, "r").

find_and_open(Dir, R_Dir, F_Name, H_File, help):-
    F_Name := find_file(Dir+R_Dir+"\\*.htm", type(file)),
    H_File := open(Dir+R_Dir+F_Name, "r").

search(Search, Dir, Where):-
  write("We are looking for \""), write(Search, in_red), write("\""),
  (G_Match_Case =:= 0 -> write(" (no case)", in_green)),
  write(" in the folder:"), nl,
  write(Dir, in_blue), nl,

  G_Dirs:=0, G_F:=0, G_N:=0, G_Old_File:=0,
  R_Dir := find_all_sub_dirs(Dir, ""),
  G_Dirs:=G_Dirs+1,
  find_and_open(Dir, R_Dir, F_Name, H_File, Where),
  (G_Old_File\=0 -> close(G_Old_File)),
  G_Old_File:=H_File,
  Temp:=0,
  Line_Number := 0,
  Line := readln(H_File),
  Line_Number := Line_Number + 1,
  one_string(Search, Line),
  (Temp=0->
    Temp:=1,
    G_F:=G_F+1,
    nl, write(G_F+". "+R_Dir+F_Name, in_green), nl
  ),
  G_N:=G_N+1,
  (G_Line_Numbers =:= 1 -> write(Line_Number+" ", in_red)),
  pretty_write(Line, Search),
  fail.

search(Search, Dir, Where):-
  (G_Old_File\=0 -> close(G_Old_File)),
  nl,
  (G_N =:= 0 ->
    write("We cannot find it.", in_green)
  else
    write("We found it "),
    write(G_N, in_red),
    write(" times in "),
    write(G_F, in_red),
    write(" files, "+(G_Dirs-1)+" subfolders.")
  ), nl.

pretty_write(Line, Search):-
  (G_Match_Case =:= 1 ->
    Sub_String = sub_string,
    String_End = string_end
  else
    Sub_String = sub_string_no,
    String_End = string_end_no
  ),
  (Sub_String(Search, Line, I, _) ->
    Sub_String(Begining, Line, 0, I),
    write(Begining),
    Len := str_length(Search),
    Sub_String(Search_prime, Line, I, Len),
    write(Search_prime, in_red),
    String_End( End, Line, I+Len, _), 
    pretty_write(End, Search)
  else
    write(Line)
  ).

R is find_all_sub_dirs(Dir, Path):-
  (
    R := Path
  ;
    F := find_file(Dir+Path+"*.*", type(directory)),
    F \= ".", F \= "..",
    R := find_all_sub_dirs(Dir, Path+F+"\\")
  ).

one_string(Search, Line):-
  (G_Match_Case =:= 1 ->
    sub_string(Search, Line, _, _)
  else
    sub_string_no(Search, Line, _, _) % (no case)
  ),
  !.

jump_over_SPJ_head(F):-
  _ is get(F, int8), % warning=1
  _ is get(F, int8), % version=2
  Int:=get(F, int8),
  Str:=get(F, int8),
  jump_int(F,Int),
  jump_str(F,Str),
  FilesList:=get(F, int32),
  jump_str(F,FilesList),
  jump_byte(F,744).

jump_byte(F,Byte):-
  for(I, 1, Byte),
    _ is get(F, int8),
  fail.
jump_byte(F,Byte).

jump_int(F,Int):-
  for(I, 1, Int),
    _ is get(F, int32),
  fail.
jump_int(F,Int).

jump_str(F,Str):-
  for(I, 1, Str),
    jump_one_str(F),
  fail.
jump_str(F,Str).

jump_one_str(F):-
  (get(F, int8)=\=255; get(F, int8)=\=254; get(F, int8)=\=255->
    write("CString error", in_red),nl
  ),
  Size:=get(F, int8),
  (Size=:=0xff -> Size:=get(F, int16)),
  (Size=:=0xffff -> Size:=get(F, int32)),
  for(I, 1, Size),
    _ is get(F, int16),
  fail.
jump_one_str(F).

